//---------------------------------------------------------------------------
#include <windows.h>
#include "tp_stub.h"
#include <math.h>
#include "common.h"
#include "blur.h"

// for __aligned_malloc()
#include <malloc.h>
// for std:bad_alloc()
#include <new>

/**
 * Oo͗p
 */
#if 0
#include <stdio.h>
static void log(const tjs_char *format, ...)
{
        va_list args;
        va_start(args, format);
        tjs_char msg[1024];
        _vsnwprintf_s(msg, 1024, format, args);
        TVPAddLog(msg);
        va_end(args);
}
#endif


//---------------------------------------------------------------------------
/*
	boxBlur gWV
	2012/01/29	0.2.5.0	IȉʂłblurłIvVdynamicǉ
	2011/12/09	0.2.1.0	"bad alloc exception thrown"c
*/
//---------------------------------------------------------------------------

#define USE_SSE2 // SSE2gȂ`


class tTVPBlurTransHandler : public iTVPDivisibleTransHandler
{
	//	boxBlur gWVnhNX̎

	tjs_int RefCount; // QƃJE^
	/*
	 * iTVPDivisibleTransHandler  QƃJE^ɂǗs
	 */

protected:
	bool          First;		// ԍŏ̌Ăяoǂ
	bool          Dynamic;		// Iȉ摜ɑΉ邩ǂ
	tjs_int64     StartTick;	// gWVJn tick count
	tjs_int64     HalfTime;		// gWVɗv鎞 / 2
	tjs_int64     Time;			// gWVɗv鎞
	tTVPLayerType LayerType;	// C^Cv
	tjs_int       Width;		// 摜̕
	tjs_int       Height;		// 摜̍

	tjs_int64     CurTime;		// ݂ tick count
	tjs_int       BlendRatio;	// uh

	double        Accel;		// isx(def=1.0)
	double        CurRatio;		// ݂̐is䗦(0`1.0)

	typedef tjs_uint32 IPIXELTYPE;	// CeOC[W̃hbg^Cv
	#define IPIXELCOLORNUM 4	// CeOC[W̃J[(ARGB)
	#define IPIXELSIZE (sizeof(IPIXELTYPE)*IPIXELCOLORNUM)

	BYTE*         Iimg1;		// src1pCeOC[W
	tjs_int       MaxXblur1, MaxYblur1; // src1̍őu[
	tjs_int       Iimgwidth1;	// CeOC[W̉
	tjs_int       Iimgheight1;	// CeOC[W̏c
	tjs_int       Iimgpitch1;	// CeOC[W̏c1hbgԂ̍كoCg
	tjs_int       CurXblur1, CurYblur1; // src1݂̌̃u[

	BYTE*         Iimg2;		// src2pCeOC[W
	tjs_int       MaxXblur2, MaxYblur2;// src2̍őu[
	tjs_int       Iimgwidth2;	// CeOC[W̉
	tjs_int       Iimgheight2;	// CeOC[W̏c
	tjs_int       Iimgpitch2;	// CeOC[W̏c1hbgԂ̍كoCg
	tjs_int       CurXblur2, CurYblur2; // src1݂̌̃u[

	tjs_uint32    *bdst1, *bdst2; // src1/src21C̃e|摜
BYTE* p;
	// ݂Ratio(0`1.0)߂
	inline double setCurrentRatio() //(tjs_int64 starttick=StartTick, tjs_int64 time=Time, tjs_int64 curtick=CurTime, double accel=Accel)
	{
		double ratio = (double)CurTime/Time;
		// ratio = 0`1.0
		ratio = (ratio < 0.0) ? 0.0 : (ratio > 1.0) ? 1.0 : ratio;
		if(Accel > 1.0)				// (ŏxXɑ)
			ratio = pow(ratio, Accel);
		else if(Accel < -1.0) {	// ㌷(ŏXɒx)
			ratio = 1.0 - ratio;
			ratio = pow(ratio, -Accel);
			ratio = 1.0 - ratio;
		}
		CurRatio = ratio;
		return ratio;
	}

	inline BYTE *getIimg1Addr(tjs_int x, tjs_int y) {
		return Iimg1 + ((MaxYblur1+1+1 + y)*Iimgpitch1 + (MaxXblur1+1 + x)*IPIXELSIZE);
	}
	inline BYTE *getIimg2Addr(tjs_int x, tjs_int y) {
		return Iimg2 + ((MaxYblur2+1+1 + y)*Iimgpitch2 + (MaxXblur2+1 + x)*IPIXELSIZE);
	}
	void addALineToIntegralImage32(
			IPIXELTYPE *dst, IPIXELTYPE *dstprev,
			tjs_uint32 *src, tjs_int srcwidth,
			tjs_int xblur);
	void drawALineFromIntegralImageToImage32(
			tjs_uint32 *dst, tjs_int dstwidth,
			IPIXELTYPE *src1, IPIXELTYPE *src2,
			tjs_int xblur, tjs_int sq);
	void tTVPBlurTransHandler::buildIntegralImage32(
			IPIXELTYPE *dst, tjs_int dstpitch,
			iTVPScanLineProvider *srcdat, tjs_int width, tjs_int height,
			tjs_int xblur, tjs_int yblur);

	// mۂ̃bp֐BTJSAlignedAlloc()bad_allocɂȂ̂
	void *local_alloc(size_t size, size_t align=0)
	{
		void * p = _aligned_malloc(size, align);
		if (p == NULL)
			throw(std::bad_alloc());
		return p;
	}
	// freeB
	void local_free(void* p)
	{
		_aligned_free(p);
	}

public:
	// RXgN^
	tTVPBlurTransHandler(tjs_uint64 time, tTVPLayerType layertype,
		tjs_int width, tjs_int height,
		tjs_int xblur1, tjs_int yblur1, tjs_int xblur2, tjs_int yblur2,
		double accel, bool dynamic)
	{
		RefCount    = 1;

		First       = true;
		LayerType   = layertype;
		Width       = width;
		Height      = height;
		Time        = time;
		HalfTime    = time / 2;
		Accel       = accel;
		Dynamic     = dynamic;

		MaxXblur1   = xblur1;
		MaxYblur1   = yblur1;
		Iimgwidth1  = width+xblur1*2+1;
		Iimgpitch1  = Iimgwidth1*IPIXELSIZE;
		Iimgheight1 = height+yblur1*2+1+1;
		Iimg1       = (BYTE*)local_alloc(Iimgheight1*Iimgpitch1, 16);

		MaxXblur2   = xblur2;
		MaxYblur2   = yblur2;
		Iimgwidth2  = width+xblur2*2+1;
		Iimgpitch2  = Iimgwidth2*IPIXELSIZE;
		Iimgheight2 = height+yblur2*2+1+1;
		Iimg2       = (BYTE*)local_alloc(Iimgheight2*Iimgpitch2, 16);

		bdst1       = (tjs_uint32*)local_alloc(Width*sizeof(*bdst1), 16);
		bdst2       = (tjs_uint32*)local_alloc(Width*sizeof(*bdst2), 16);
	}

	// fXgN^
	virtual ~tTVPBlurTransHandler()
	{
		local_free(Iimg1);
		local_free(Iimg2);
		local_free(bdst1);
		local_free(bdst2);
	}

	tjs_error TJS_INTF_METHOD AddRef()
	{
		// iTVPBaseTransHandler  AddRef
		// QƃJE^CNg
		RefCount ++;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD Release()
	{
		// iTVPBaseTransHandler  Release
		// QƃJE^fNgA0 ɂȂȂ delete this
		if(RefCount == 1)
			delete this;
		else
			RefCount--;
		return TJS_S_OK;
	}


	tjs_error TJS_INTF_METHOD SetOption(
			/*in*/iTVPSimpleOptionProvider *options // option provider
		)
	{
		// iTVPBaseTransHandler  SetOption
		// Ƃɂ邱ƂȂ
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD StartProcess(tjs_uint64 tick);

	tjs_error TJS_INTF_METHOD EndProcess();

	tjs_error TJS_INTF_METHOD Process(
			tTVPDivisibleData *data);

	tjs_error TJS_INTF_METHOD MakeFinalImage(
			iTVPScanLineProvider ** dest,
			iTVPScanLineProvider * src1,
			iTVPScanLineProvider * src2)
	{
		*dest = src2; // ɍŏI摜 src2
		return TJS_S_OK;
	}
};


//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPBlurTransHandler::StartProcess(tjs_uint64 tick)
{
	// gWV̉ʍXV񂲂ƂɌĂ΂

	// gWV̉ʍXVɂA܂ŏ StartProcess Ă΂
	// ̂ Process Ă΂ ( ̈𕪊Ăꍇ )
	// Ō EndProcess Ă΂

	if (First)	// ŏ̎s
		StartTick = tick;
	if (Dynamic)		// IʍXVKvȂ玟Firstɂ
		First = true;	// Integral Imageč쐬BʁB

	// 摜ZɕKvȊep[^vZ
	CurTime = ((tjs_int64)tick - StartTick);
	if (CurTime > Time) CurTime = Time;

	// BlendRatio
	BlendRatio = tjs_int(CurTime * 255 / Time);
	if(BlendRatio > 255) BlendRatio = 255;

	//CurXblur/CurYblur
	CurXblur1 = tjs_int(MaxXblur1*CurTime/Time);
	CurYblur1 = tjs_int(MaxYblur1*CurTime/Time);
	CurXblur2 = tjs_int(MaxXblur2*(Time-CurTime)/Time);
	CurYblur2 = tjs_int(MaxYblur2*(Time-CurTime)/Time);

	return TJS_S_TRUE;
}

//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPBlurTransHandler::EndProcess()
{
	// gWV̉ʍXV񕪂I邲ƂɌĂ΂

	if(BlendRatio == 255) return TJS_S_FALSE; // gWVI

	return TJS_S_TRUE;
}


/*
 * CeOC[W(=dst) src vZĈꃉCǉ
 * dstɂ̓͊ɊmۂĂ̂Ƃ
 */
void tTVPBlurTransHandler::addALineToIntegralImage32(
		IPIXELTYPE *dst, IPIXELTYPE *dstprev, tjs_uint32 *src, tjs_int srcwidth, tjs_int xblur)
{
#ifndef USE_SSE2
	tjs_uint32 r_sum = 0, g_sum = 0, b_sum = 0;
	tjs_uint32 col = *src;
	for (int x = -xblur-1; x < 0; x++) {
		b_sum += (col>> 0)&0xff;
		g_sum += (col>> 8)&0xff;
		r_sum += (col>>16)&0xff;
		*dst++ = b_sum + *dstprev++;
		*dst++ = g_sum + *dstprev++;
		*dst++ = r_sum + *dstprev++;
		dst++, dstprev++;	// 󂫕XLbv
	}
	for (int x = 0; x < srcwidth-1; x++) {
		col = *src++;
		b_sum += (col>> 0)&0xff;
		g_sum += (col>> 8)&0xff;
		r_sum += (col>>16)&0xff;
		*dst++ = b_sum + *dstprev++;
		*dst++ = g_sum + *dstprev++;
		*dst++ = r_sum + *dstprev++;
		dst++, dstprev++;	// 󂫕XLbv
	}
	col = *src++;
	for (int x = srcwidth-1; x < srcwidth+xblur; x++) {
		b_sum += (col>> 0)&0xff;
		g_sum += (col>> 8)&0xff;
		r_sum += (col>>16)&0xff;
		*dst++ = b_sum + *dstprev++;
		*dst++ = g_sum + *dstprev++;
		*dst++ = r_sum + *dstprev++;
		dst++, dstprev++;	// 󂫕XLbv
	}
#else
	// CCAZu̓NXoϐɃANZXłȂ(Ɖ킸ɕςȒlɂȂ)
	// ̂ŁA[Jϐɂ̂݃ANZXĂ邱Ƃɒ
	__asm {
		mov			esi,  src
		mov			edi,  dst
		pxor		xmm1, xmm1	// unpackp
		pxor		xmm2, xmm2	// sump
		mov			ebx,  dstprev
		mov			ecx,  xblur
		inc			ecx
		movd		xmm0, [esi]
		punpcklbw	xmm0, xmm1	// byte -> word
		punpcklwd	xmm0, xmm1	// word -> tjs_uint32
	BUILDINTIMAGE_LOOP1:
		paddd		xmm2, xmm0
		movdqa		xmm3, [ebx]
		paddd		xmm3, xmm2
		movdqa		[edi],xmm3
		add			edi,  16
		add			ebx,  16
		loop		BUILDINTIMAGE_LOOP1
		mov			ecx,  srcwidth
		dec			ecx
	BUILDINTIMAGE_LOOP2:
		movd		xmm0, [esi]
		punpcklbw	xmm0, xmm1	// byte -> word
		punpcklwd	xmm0, xmm1	// word -> tjs_uint32
		paddd		xmm2, xmm0
		movdqa		xmm3, [ebx]
		paddd		xmm3, xmm2
		movdqa		[edi],xmm3
		add			esi,  4
		add			edi,  16
		add			ebx,  16
		loop		BUILDINTIMAGE_LOOP2
		mov			ecx,  xblur
		inc			ecx
		movd		xmm0, [esi]
		punpcklbw	xmm0, xmm1	// byte -> word
		punpcklwd	xmm0, xmm1	// word -> tjs_uint32
	BUILDINTIMAGE_LOOP3:
		paddd		xmm2, xmm0
		movdqa		xmm3, [ebx]
		paddd		xmm3, xmm2
		movdqa		[edi],xmm3
		add			edi,  16
		add			ebx,  16
		loop		BUILDINTIMAGE_LOOP3
	}
#endif
}

/*
 * CeOC[W(=src)dstɈꃉC`悷
 */
void tTVPBlurTransHandler::drawALineFromIntegralImageToImage32(
		tjs_uint32 *dst, tjs_int dstwidth, IPIXELTYPE *src1, IPIXELTYPE *src2, tjs_int xblur, tjs_int sq)
{
#ifndef USE_SSE2
	int xblurwidth = (xblur*2+1)*IPIXELCOLORNUM;
	for (int x = 0; x < dstwidth; x++) {
		tjs_uint32 b = (*src1 - *(src1+xblurwidth) - *src2 + *(src2+xblurwidth))/sq;
		src1++, src2++;
		tjs_uint32 g = (*src1 - *(src1+xblurwidth) - *src2 + *(src2+xblurwidth))/sq;
		src1++, src2++;
		tjs_uint32 r = (*src1 - *(src1+xblurwidth) - *src2 + *(src2+xblurwidth))/sq;
		src1+=2, src2+=2;
		*dst++ = ((r&0xff)<<16) | ((g&0xff)<<8) | (b&0xff);
	}
#else
	int xblurwidthsize = (xblur*2+1)*IPIXELSIZE;
	//  rsqf  1/sq łȂ̂́AvZ(Px_)덷傫߂
	// 摜ςɂȂ邱Ƃ邩BFẐɌ߂덷Ȃ߁B
	float rsqf = (float)(1<<16)/sq;
	__asm {
		mov			esi,  src1
		mov			edx,  src2
		mov			edi,  dst
		mov			ebx,  xblurwidthsize
		mov			eax,  rsqf
		movd		xmm1, eax
		pshufd		xmm1, xmm1, 0x0
		mov			ecx,  dstwidth
		sar			ecx,  2
		// ŏ 4dot ƂɏBŃXs[h񊄑B
	BOXBLUR_LOOP1:
		movdqa		xmm0, [esi]
		paddd		xmm0, [edx+ebx]
		psubd		xmm0, [esi+ebx]
		psubd		xmm0, [edx]			// xmm0 = |sum_a|sum_r|sum_g|sum_b}
		cvtdq2ps	xmm0, xmm0
		mulps		xmm0, xmm1			// xmm0 *= 65536/sq
		cvtps2dq	xmm0, xmm0
		psrld		xmm0, 16			// xmm0 = |a|r|g|b|(tjs_uint32)
		packssdw	xmm0, xmm0
		packuswb	xmm0, xmm0			// xmm0 = |a|r|g|b|(byte)
		movd		[edi],xmm0
		add			esi, 16
		add			edx, 16
		add			edi, 4

		movdqa		xmm0, [esi]
		paddd		xmm0, [edx+ebx]
		psubd		xmm0, [esi+ebx]
		psubd		xmm0, [edx]			// xmm0 = |sum_a|sum_r|sum_g|sum_b}
		cvtdq2ps	xmm0, xmm0
		mulps		xmm0, xmm1			// xmm0 *= 65536/sq
		cvtps2dq	xmm0, xmm0
		psrld		xmm0, 16			// xmm0 = |a|r|g|b|(tjs_uint32)
		packssdw	xmm0, xmm0
		packuswb	xmm0, xmm0			// xmm0 = |a|r|g|b|(byte)
		movd		[edi],xmm0
		add			esi, 16
		add			edx, 16
		add			edi, 4

		movdqa		xmm0, [esi]
		paddd		xmm0, [edx+ebx]
		psubd		xmm0, [esi+ebx]
		psubd		xmm0, [edx]			// xmm0 = |sum_a|sum_r|sum_g|sum_b}
		cvtdq2ps	xmm0, xmm0
		mulps		xmm0, xmm1			// xmm0 *= 65536/sq
		cvtps2dq	xmm0, xmm0
		psrld		xmm0, 16			// xmm0 = |a|r|g|b|(tjs_uint32)
		packssdw	xmm0, xmm0
		packuswb	xmm0, xmm0			// xmm0 = |a|r|g|b|(byte)
		movd		[edi],xmm0
		add			esi, 16
		add			edx, 16
		add			edi, 4

		movdqa		xmm0, [esi]
		paddd		xmm0, [edx+ebx]
		psubd		xmm0, [esi+ebx]
		psubd		xmm0, [edx]			// xmm0 = |sum_a|sum_r|sum_g|sum_b}
		cvtdq2ps	xmm0, xmm0
		mulps		xmm0, xmm1			// xmm0 *= 65536/sq
		cvtps2dq	xmm0, xmm0
		psrld		xmm0, 16			// xmm0 = |a|r|g|b|(tjs_uint32)
		packssdw	xmm0, xmm0
		packuswb	xmm0, xmm0			// xmm0 = |a|r|g|b|(byte)
		movd		[edi],xmm0
		add			esi, 16
		add			edx, 16
		add			edi, 4
		dec			ecx
		jnz			BOXBLUR_LOOP1

		// chbg
		mov			ecx,  dstwidth
		and			ecx,  3
		jz			BOXBLUR_LOOP_END
	BOXBLUR_LOOP2:
		movdqa		xmm0, [esi]
		paddd		xmm0, [edx+ebx]
		psubd		xmm0, [esi+ebx]
		psubd		xmm0, [edx]			// xmm0 = |sum_a|sum_r|sum_g|sum_b}
		cvtdq2ps	xmm0, xmm0
		mulps		xmm0, xmm1			// xmm0 *= 65536/sq
		cvtps2dq	xmm0, xmm0
		psrld		xmm0, 16			// xmm0 = |a|r|g|b|(tjs_uint32)
		packssdw	xmm0, xmm0
		packuswb	xmm0, xmm0			// xmm0 = |a|r|g|b|(byte)
		movd		[edi],xmm0
		add			esi, 16
		add			edx, 16
		add			edi, 4
		loop		BOXBLUR_LOOP2
	BOXBLUR_LOOP_END:
	}
#endif
}

/*
 * buildIntegralImage: 摜CeOC[W쐬
 */
void tTVPBlurTransHandler::buildIntegralImage32(
		IPIXELTYPE *dst, tjs_int dstpitch,
		iTVPScanLineProvider *srcdat, tjs_int width, tjs_int height,
		tjs_int xblur, tjs_int yblur)
{
	// iimgp  ʂɏcu[+1Əchbgǉ傫߉ʁB
	// ŏ̗0Ŗ߂
	for	(int x = -xblur-1; x < width+xblur; x++)
		*dst++ = 0, *dst++ = 0, *dst++ = 0, dst++;
	// ̗́u܂ł̘av{u̒lv
	tjs_uint32 *src;
	srcdat->GetScanLine(0, (const void**)&src);	// j炵G[`FbNȂ
//log(L"dst=0x%08x, dstpitch=%d, src=0x%08x, width=%d, height=%d, xblur=%d, yblur=%d", 
//	dst, dstpitch, src, width, height, xblur, yblur);
	for (int y = -yblur-1; y < 0; y++) {
		addALineToIntegralImage32(dst, (tjs_uint32*)((BYTE*)dst-dstpitch), src, width, xblur);
		dst = (IPIXELTYPE*)((BYTE*)dst + dstpitch);
	}
	for (int y = 0; y < height-1; y++) {
		srcdat->GetScanLine(y, (const void**)&src);	// j炵G[`FbNȂ
		addALineToIntegralImage32(dst, (tjs_uint32*)((BYTE*)dst-dstpitch), src, width, xblur);
		dst = (IPIXELTYPE*)((BYTE*)dst + dstpitch);
	}
	srcdat->GetScanLine(height-1, (const void**)&src);	// j炵G[`FbNȂ
	for (int y = height; y < height+yblur; y++) {
		addALineToIntegralImage32(dst, (tjs_uint32*)((BYTE*)dst-dstpitch), src, width, xblur);
		dst = (IPIXELTYPE*)((BYTE*)dst + dstpitch);
	}
}


//---------------------------------------------------------------------------
tjs_error TJS_INTF_METHOD tTVPBlurTransHandler::Process(
			tTVPDivisibleData *data)
{
	// gWV̊ë悲ƂɌĂ΂
	// gg͉ʂXVƂɂ̗̈ɕȂ珈ŝ
	// ̃\bh͒ʏAʍXVɂĂ΂

	// data ɂ͗̈摜Ɋւ񂪓Ă

	if (First) {	// ŏ̎s
		// ́ACeOC[WB
		buildIntegralImage32((IPIXELTYPE*)Iimg1, Iimgpitch1, data->Src1, Width, Height, MaxXblur1, MaxYblur1);
		buildIntegralImage32((IPIXELTYPE*)Iimg2, Iimgpitch2, data->Src2, Width, Height, MaxXblur2, MaxYblur2);
		First = false;
//log(L"Iimg1=0x%08x, Iimgwidth1=%d, Iimgheight1=%d, Iimgpitch1=%d, MaxXblur1=%d, MaxYblur1=%d",
//		Iimg1, Iimgwidth1, Iimgheight1, Iimgpitch1, MaxXblur1, MaxYblur1);
//log(L"Iimg2=0x%08x, Iimgwidth2=%d, Iimgheight2=%d, Iimgpitch2=%d, MaxXblur2=%d, MaxYblur2=%d",
//		Iimg2, Iimgwidth2, Iimgheight2, Iimgpitch2, MaxXblur2, MaxYblur2);
	}

	//  boxBlur
	int sq1 = (CurXblur1*2+1)*(CurYblur1*2+1), sq2 = (CurXblur2*2+1)*(CurYblur2*2+1);
	// CƂɏ
	for (int n = 0; n < data->Height; n++) {
		int	dstx = data->DestLeft;
		int	dsty = data->DestTop + n;
		int srcx = data->Left;
		int srcy = data->Top + n;
		// bdst1  src1 ̈ꃉCBlurz߂
		IPIXELTYPE *src_u, *src_d;
		src_u = (IPIXELTYPE*)getIimg1Addr(srcx-(CurXblur1+1), srcy-(CurYblur1+1));	// 
		src_d = (IPIXELTYPE*)getIimg1Addr(srcx-(CurXblur1+1), srcy+(CurYblur1+0));	// 
		drawALineFromIntegralImageToImage32(bdst1, data->Width, src_u, src_d, CurXblur1, sq1);
		// bdst2  src2 ̈ꃉCBlurz߂
		src_u = (IPIXELTYPE*)getIimg2Addr(srcx-(CurXblur2+1), srcy-(CurYblur2+1));	// 
		src_d = (IPIXELTYPE*)getIimg2Addr(srcx-(CurXblur2+1), srcy+(CurYblur2+0));	// 
		drawALineFromIntegralImageToImage32(bdst2, data->Width, src_u, src_d, CurXblur2, sq2);

		tjs_uint32 *dst;
		data->Dest->GetScanLineForWrite(data->DestTop+n, (void**)&dst);
		// ŁAbdst1bdst2dstɓ]
		if (LayerType == ltAlpha) {
			TVPConstAlphaBlend_SD_d(dst+data->DestLeft-data->Left,
									bdst1, bdst2, data->Width, BlendRatio);
		} else if (LayerType == ltAddAlpha) {
			TVPConstAlphaBlend_SD_a(dst+data->DestLeft-data->Left,
									bdst1, bdst2, data->Width, BlendRatio);
		} else {
			TVPConstAlphaBlend_SD(dst+data->DestLeft-data->Left,
									bdst1, bdst2, data->Width, BlendRatio);
		}
	}

	return TJS_S_OK;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
class tTVPBlurTransHandlerProvider : public iTVPTransHandlerProvider
{
	tjs_uint RefCount; // QƃJE^
public:
	tTVPBlurTransHandlerProvider() { RefCount = 1; }
	~tTVPBlurTransHandlerProvider() {; }

	tjs_error TJS_INTF_METHOD AddRef()
	{
		// iTVPBaseTransHandler  AddRef
		// QƃJE^CNg
		RefCount ++;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD Release()
	{
		// iTVPBaseTransHandler  Release
		// QƃJE^fNgA0 ɂȂȂ delete this
		if(RefCount == 1)
			delete this;
		else
			RefCount--;
		return TJS_S_OK;
	}

	tjs_error TJS_INTF_METHOD GetName(
			/*out*/const tjs_char ** name)
	{
		// ̃gWV̖OԂ
		if(name) *name = TJS_W("blur");
		return TJS_S_OK;
	}


	tjs_error TJS_INTF_METHOD StartTransition(
			/*in*/iTVPSimpleOptionProvider *options, // option provider
			/*in*/iTVPSimpleImageProvider *imagepro, // image provider
			/*in*/tTVPLayerType layertype, // destination layer type
			/*in*/tjs_uint src1w, tjs_uint src1h, // source 1 size
			/*in*/tjs_uint src2w, tjs_uint src2h, // source 2 size
			/*out*/tTVPTransType *type, // transition type
			/*out*/tTVPTransUpdateType * updatetype, // update typwe
			/*out*/iTVPBaseTransHandler ** handler // transition handler
			)
	{
		if(type) *type = ttExchange; // transition type : exchange
		if(updatetype) *updatetype = tutDivisible;
			// update type : divisible
		if(!handler) return TJS_E_FAIL;
		if(!options) return TJS_E_FAIL;

		if(src1w != src2w || src1h != src2h)
			return TJS_E_FAIL; // src1  src2 ̃TCYvĂȂƑʖ


		// IvV𓾂
		tTJSVariant tmp;
		tjs_uint64 time;
		tjs_uint32 xblur1 = 32, yblur1 = 32;
		tjs_uint32 xblur2 = 32, yblur2 = 32;
		double accel = 1.0;
		bool dynamic = false;

		if(TJS_FAILED(options->GetValue(TJS_W("time"), &tmp)))
			return TJS_E_FAIL; // time w肳ĂȂ
		if(tmp.Type() == tvtVoid) return TJS_E_FAIL;
		time = (tjs_int64)tmp;
		if(time < 2) time = 2; // ܂菬Ȑlw肷Ɩ肪N̂

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur1x"), &tmp)))
			if(tmp.Type() != tvtVoid) xblur1 = (tjs_int)tmp;
		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur1y"), &tmp)))
			if(tmp.Type() != tvtVoid) yblur1 = (tjs_int)tmp;
		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur1"), &tmp)))
			if(tmp.Type() != tvtVoid) xblur1 = yblur1 = (tjs_int)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur2x"), &tmp)))
			if(tmp.Type() != tvtVoid) xblur2 = (tjs_int)tmp;
		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur2y"), &tmp)))
			if(tmp.Type() != tvtVoid) yblur2 = (tjs_int)tmp;
		if(TJS_SUCCEEDED(options->GetValue(TJS_W("blur2"), &tmp)))
			if(tmp.Type() != tvtVoid) xblur2 = yblur2 = (tjs_int)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("accel"), &tmp)))
			if(tmp.Type() != tvtVoid) accel = (double)tmp;

		if(TJS_SUCCEEDED(options->GetValue(TJS_W("dynamic"), &tmp)))
			if(tmp.Type() != tvtVoid) dynamic = ((tjs_int)tmp != 0);

		// IuWFNg쐬
		*handler = new tTVPBlurTransHandler(time, layertype,
			src1w, src1h,
			xblur1, yblur1, xblur2, yblur2,
			accel, dynamic);

		return TJS_S_OK;
	}

} static * BlurTransHandlerProvider;
//---------------------------------------------------------------------------
void RegisterBlurTransHandlerProvider()
{
	// TVPAddTransHandlerProvider găgWVnhvoC_
	// o^
	BlurTransHandlerProvider = new tTVPBlurTransHandlerProvider();
	TVPAddTransHandlerProvider(BlurTransHandlerProvider);
}
//---------------------------------------------------------------------------
void UnregisterBlurTransHandlerProvider()
{
	// TVPRemoveTransHandlerProvider găgWVnhvoC_
	// o^
	TVPRemoveTransHandlerProvider(BlurTransHandlerProvider);
	BlurTransHandlerProvider->Release();
}
//---------------------------------------------------------------------------
